﻿<cfcomponent>
	
	<!--- 
	* メンバ変数
	--->
	<cfset s_MapPrice = "">
	<cfset s_MapState = "">
	<cfset initialized = false>
	
	<!--- 
	* コンストラクタ
	--->
	<cffunction name="init" access="public" output="no" returntype="Any">
		
		<cfif s_MapPrice EQ "">
			<!--- 価格の情報の初期化 --->
			<cfset s_MapPrice = StructNew()>
			
			<cfset s_MapPrice[""] 	= 0>
			<cfset s_MapPrice["0"] 	= 800>
			<cfset s_MapPrice["1"] 	= 1000>
			<cfset s_MapPrice["2"] 	= 100>
			<cfset s_MapPrice["3"] 	= 200>
			<cfset s_MapPrice["4"] 	= 300>
			<cfset s_MapPrice["5"] 	= 200>
			<cfset s_MapPrice["6"] 	= 300>
			<cfset s_MapPrice["7"] 	= 300>
			<cfset s_MapPrice["8"] 	= 100>
		</cfif>
		
		<cfif s_MapState EQ "">
			<!--- 状態の情報の初期化 --->
			<cfset s_MapState = StructNew()>
			
			<cfset s_MapState[""] = ListToArray("0,1")>
			<cfset s_MapState["0"] = ListToArray("0,2,3")>
			<cfset s_MapState["1"] = ListToArray("1,4")>
			<cfset s_MapState["0,2"] = ListToArray("0,2,5,6")>
			<cfset s_MapState["0,3"] = ListToArray("0,3,6,7")>
			<cfset s_MapState["1,4"] = ListToArray("1,4,7,8")>
			<cfset s_MapState["0,2,5"] = ListToArray("0,2,5,6")>
			<cfset s_MapState["0,2,6"] = ListToArray("0,2,5,6")>
			<cfset s_MapState["0,2,5,6"] = ListToArray("0,2,5,6")>
			<cfset s_MapState["0,3,6"] = ListToArray("0,3,6,7")>
			<cfset s_MapState["0,3,7"] = ListToArray("0,3,6,7")>
			<cfset s_MapState["0,3,6,7"] = ListToArray("0,3,6,7")>
			<cfset s_MapState["1,4,7"] = ListToArray("1,4,7,8")>
			<cfset s_MapState["1,4,8"] = ListToArray("1,4,7,8")>
			<cfset s_MapState["1,4,7,8"] = ListToArray("1,4,7,8")>
		</cfif>
		
		<cfset this.initialized = true>
		
		<cfreturn this>
	</cffunction>
	
	
	<!--- 
	* 計算
	* 価格と次の状態を含むStructを返す
	--->
	<cffunction name="doCalc" access="remote" returntype="Struct" returnformat="JSON">
		
		<cfargument name="lst" required="true" type="string" >
		
		<cfif initialized EQ false>
			<cfset this.init()>
		</cfif>
		
		<cfscript>
			var stRet = structNew();
			stRet.IsError = false;
			stRet.Price = 0;
			stRet.NextState = ArrayNew(1);
		</cfscript>
		
		<cftry>
			
			<!--- 価格を計算 --->
			<cfset var arraySelected = ListToArray(#lst#)>
			<cfscript>
				var price = 0;
				var cnt = 0;
				var len = arraylen(arraySelected);
				for(cnt = 1; cnt<=len; cnt++)
				{
					var key = arraySelected[cnt];
					price = price + s_MapPrice[key];
				}
			</cfscript>
			<cfset stRet.Price = price>
			
			<!--- 次の状態を取得 --->
			<cfset stRet.NextState = s_MapState[#lst#]>
			
			<cfcatch type="any">
				<cfset stRet.Price = 0> 
				<cfset stRet.IsError = TRUE>
				<cfset stRet.NextState =s_MapState[""]>
			</cfcatch>
		</cftry>
		
		<cfreturn stRet>
	</cffunction>
	
	
	<!--- 
	* XMLを作成
	--->
	<cffunction name="makexml" access="remote" returntype="xml">
		
		<cfargument name="lst" required="true" type="string" >
		
		<cfif this.initialized EQ false>
			<cfset this.init()>
		</cfif>
		
		<cftry>
		
			<cfscript>
				var strRet = "<PizzaInfo><Price></Price><Parts></Parts><Error></Error></PizzaInfo>";
				var xmlRet = XmlParse(strRet);
			</cfscript>
			
			<cfset var arraySelected = ListToArray(#lst#)>
			<cfscript>
				var price = 0;
				var cnt = 0;
				var len = arraylen(arraySelected);
				for(cnt = 1; cnt<=len; cnt++)
				{
					var key = arraySelected[cnt];
					
					xmlRet.PizzaInfo.Parts.XmlChildren[cnt] = xmlElemNew(xmlRet, "id");
					xmlRet.PizzaInfo.Parts.id[cnt].XMLText= key;
					
					price = price + s_MapPrice[key];
				}
			</cfscript>
			<cfset xmlRet.PizzaInfo.Price.XMLText = price>
			
			<cfcatch type="any">
				
			</cfcatch>
		</cftry>
		
		<cfreturn xmlRet>
	</cffunction>
	
</cfcomponent>